/*
    epoch.c, Copyright (C) 2001 Joe Laffey

    Laughably simple C program for displaying the current time in seconds
    since the Epoch (Midnight Jan 1, 1970 on most systems).

    Note that many implementations of date(1) now include the "%s" option
    which displays the same thing. At the time of this writing NetBSD's
    did NOT so I made this. Linux's date(1) DID have the "%s" option.

    This implementation will display the date in seconds followed by a new
    line, unless you pass ANY argument. In which case, it will NOT include
    the new line, which may be useful for scripts.


    This program is free software; you can redistribute it and/or modify   
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or 
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,  
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License   
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <time.h>



/* The fun starts here */
int main (int argc, char **argv)
{
	time_t	theTime;	/* holds the time returned from time() */

	theTime = time((time_t*)0L);	/* get the time */

	if(theTime < 0)	/* check for error */
	{
		fprintf(stderr, "Unable to get current time via time() !\n");
		exit(1); /* nothing more to do here */
	}

	if( argc < 2 )		/* check number of args, argc counts the program name too */
		printf("%lu\n", theTime);	/* print with newline */
	else
		printf("%lu", theTime);		/* print without new line */
		
	return(0); /* that's all folks! */
	
	/* I said it was laughably simple! */
}


/* end epoch.c */
