/* 
    Whatmask, Copyright (C) 2001 Joe Laffey      
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "main.h"

int main(int argc, char** argv)
{
	unsigned int 	val1,
			val2,
			val3,
			val4;

	int		retNum;
	
	if(argc != 2)
		usage();

	if(argv[1][0] == '/') /* drop a leading slash */
		argv[1] += 1;

	retNum = sscanf(argv[1], "%u.%u.%u.%u", &val1, &val2, &val3, &val4);
	
	if(retNum == 1)
        {
		/*assume CIDR */
		return ctonm_main(argv[1], val1);
        }
	else if(retNum == 4)
	{
		return nmtoc_main(argv[1], val1, val2, val3, val4);
	}
	else
		usage();

	return(0);
}

void usage(void)
{


	printf("\n%s version %s, Copyright (C) 2001  Joe Laffey <joe@laffeycomputer.com>\n", PACKAGE, VERSION);
	printf("Visit: http://www.laffeycomputer.com/software.html for updates.\n\n");

	printf("%s comes with ABSOLUTELY NO WARRANTY; for details see the COPYING file\nthat accompained this distribution. ", PACKAGE);
	printf("This is free software, and you are welcome\nto redistribute it");
	printf(" under the terms of GNU PUBLIC LICENSE.\n\n");
	printf("Usage:   %s <CIDR bits>\n", PACKAGE);
	printf("  - or -\n");
	printf("         %s <subnet mask>\n", PACKAGE);
	printf("  - or -\n");
	printf("         %s <wildcard bit mask>\n\n", PACKAGE);
	printf("NOTE: %s will autodetect the input and show you all three.\n\n", PACKAGE);
	exit(EX_USAGE);

}
