#include "makenetmask.h"

/* Creates a netmask string (e.g. "255.255.255.192")  */
/* from an unsgined int. The argument buf should have */
/* at least NM_LEN bytes allocated to it.             */
char* makenetmask( unsigned int myVal, char* buf)
{
	unsigned int 	val1,
			val2,
			val3,
			val4;


	val1 = myVal & 0xff000000;
        val1 = val1  >>24;
        val2 = myVal & 0x00ff0000;
        val2 = val2  >>16;
        val3 = myVal & 0x0000ff00;
        val3 = val3 >>8;
        val4 = myVal & 0x000000ff;

	snprintf(buf, NM_LEN, "%u.%u.%u.%u", val1, val2, val3, val4);

	return(buf);

}
