/* 
    Whatmask, Copyright (C) 2001 Joe Laffey      
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "ctonm.h"
#include "bitcount.h"
#include "validatemask.h"


int nmtoc_main(char* argv_one, unsigned int val1, unsigned int val2, unsigned int val3, unsigned int val4)
{
        
        unsigned int 	myVal = 0;

	char* 	numBits[3];
	
	char*	myNetmask[NM_LEN];
	char*	myNetmask2[NM_LEN];
	

	myVal |= val4;
	val3 <<= 8;
	myVal |= val3;
	val2 <<= 16;
	myVal |= val2;
	val1 <<= 24;
	myVal |= val1;

	if( validatemask(myVal) )
	{
		/* not it so we can see if it is cisco-style */
		myVal = ~myVal;	
	}

	if( validatemask(myVal) )
	{
		fprintf(stderr, "%s: \"%s\" is not a valid subnet mask or source bit mask!\n", PACKAGE, argv_one);
		return(EX_USAGE);
	}
		
	

        snprintf((char*)numBits, 3 , "%u", bitcount(myVal));


	makenetmask(myVal, (char*)myNetmask);
	makenetmask(~myVal, (char*)myNetmask2);
	
	printdata( (char*)numBits, (char*)myNetmask, (char*)myNetmask2);

	return(0);
}
