Summary: Whatmask - Convert between different netmask types and display helpful network information.
Name: whatmask
Version: 1.1
Release: 1
Copyright: GNU Public License
Group: Utilities/Network
Source: http://downloads.laffeycomputer.com/current_builds/whatmask/whatmask-1.1.tar.gz
URL: http://www.laffeycomputer.com/whatmask.html                
%description
Whatmask is a small C program that will help you with network settings.

Whatmask can work in two modes. The first mode (which is how prior versions
worked) is to invoke Whatmask with only a subnet mask as the argument. In 
this mode Whatmask will echo back the subnet mask in three formats, plus
the number of useable addresses in the range.

Netmask Notations supported:

 Name                  Example
---------------------------------
 CIDR                         /24
 Netmask            255.255.255.0
 Wilcard Bits           0.0.0.255


The above notations are all identical. CIDR notation commonly has a "/" in
front of the number (representing the number of bits). Whatmask can accept
these notations with or without a slash. This notation is used more and more
recently. A lot of popular routers and software support this notation.

Netmask notation is pretty much the standard old-school way of doing it. It 
is supported by most systems (Un*x, Win, Mac, etc.).

Wilcard bits are similar to the netmask, but they are the logical not of the
netmask. This notation is used by a number of popular routers (and nobody
knows why...).

To use Whatmask in the original mode simply type "whatmask <notation>" The
notation can be in any of the three formats and Whatmask will automagically
figure out what it is and display all three notations.

To find out more about subnets and netmasks see the References section below.

To use Whatmask in its second mode execute Whatmask with any ip address
within the subnet, followed by a slash ('/'), followed by the subnet mask in
any format. (e.g. 192.168.0.23/255.255.255.224, or 192.168.0.23/27)

Whatmask will echo back the following:

- The netmask in the following formats: CIDR, Netmask, Wildcard Bits
- The Network Address
- The Broadcast Address
- The number of Usable IP Addresses
- The First Usable IP Address
- The Last Usable IP Address

(Whatnet assumes that the Broadcast address is the highest address in the
subnet. This is the most common configuration.)

%prep
%setup
./configure

%build
make

%install
make install

%clean
make clean

%files
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README       

/usr/local/bin/whatmask
/usr/local/bin/whatnet

%changelog
* Thu Sep 13 2001 Joe Laffey <software@laffeycomputer.com>
- Upgraded to version 1.1.

* Thu Jul 05 2001 Joe Laffey <software@laffeycomputer.com>
- Initial RPM packaging

%vendor Laffey Computer Imaging
%packager Joe Laffey <software@laffeycomputer.com>

